function initLogin() {

    // https://developer.mozilla.org/en-US/docs/Archive/Add-ons/Code_snippets/Preferences
    // Get the "accessibility." branch
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    prefs = prefs.getBranch("extensions.tbwice_thunderbird.");
    
    if(prefs.getCharPref("wice_server")) {
	// prefs is an nsIPrefBranch.
	// Look in the above section for examples of getting one.
	document.getElementById("wice_server").value = prefs.getCharPref("wice_server");
	document.getElementById("wice_mandant").value = prefs.getCharPref("wice_mandant");
	document.getElementById("wice_username").value = prefs.getCharPref("wice_username");
	document.getElementById("wice_password").value = decrypt(prefs.getCharPref("wice_password"));
	//document.getElementById("wice_cookie").value = prefs.getCharPref("wice_cookie");
    }
    
    //document.documentElement.getButton("accept").disabled = true; // disabled by default, user must first click on "Login"
    document.documentElement.getButton("extra1").disabled = false; // disabled by default, user must first click on "Login"
}


function onCancel() {
}


function onAccept() {
}


function save_preferences() {
    
    // https://developer.mozilla.org/en-US/docs/Archive/Add-ons/Code_snippets/Preferences
    // Get the "accessibility." branch
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    prefs = prefs.getBranch("extensions.tbwice_thunderbird.");
    
    // prefs is an nsIPrefBranch.
    // Look in the above section for examples of getting one.
    prefs.setCharPref("wice_server", document.getElementById("wice_server").value); 
    prefs.setCharPref("wice_mandant", document.getElementById("wice_mandant").value); 
    prefs.setCharPref("wice_username", document.getElementById("wice_username").value); 
    prefs.setCharPref("wice_password", encrypt(document.getElementById("wice_password").value)); 
    
}



function getCookie() {
    var textbox = document.getElementById("wice_server");
    console.log("Setting Wice server "+textbox.value);

    var url = document.getElementById("wice_server").value + "/pserv/base/json";
    var params = "method=login&mandant_name="+document.getElementById("wice_mandant").value+"&username="+document.getElementById("wice_username").value+"&password="+document.getElementById("wice_password").value;
    console.log("Posting to " + url + "...");
    
    makePOSTRequest(url, params);

}



function makePOSTRequest(url, parameters) {
    http_request = false;
    if (window.XMLHttpRequest) { // Mozilla, Safari,...
	http_request = new XMLHttpRequest();
	if (http_request.overrideMimeType) {
	    // set type accordingly to anticipated content type
            //http_request.overrideMimeType('text/xml');
            http_request.overrideMimeType('text/html');
	}
    } else if (window.ActiveXObject) { // IE
	try {
            http_request = new ActiveXObject("Msxml2.XMLHTTP");
	} catch (e) {
            try {
		http_request = new ActiveXObject("Microsoft.XMLHTTP");
            } catch (e) {}
	}
    }
    if (!http_request) {
	alert('Cannot create XMLHTTP instance');
	return false;
    }

    //http_request.onreadystatechange = alertContents; // please read notes about this in the function directly
    http_request.onreadystatechange = function() { //Call a function when the state changes.
	console.log("STATE CHANGE "+http_request.status+" - "+http_request.readyState);
        if (http_request.readyState == 4 && http_request.status == 200) {
            console.log("POST result: " + http_request.responseText);
	    var json_data = JSON.parse(http_request.responseText);
	    var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
	    prefs = prefs.getBranch("extensions.tbwice_thunderbird.");
	    
            console.log("COOKIE: " + json_data.cookie);
	    // prefs is an nsIPrefBranch.
	    // Look in the above section for examples of getting one.
	    prefs.setCharPref("wice_cookie", json_data.cookie); 

	    if(json_data.cookie) {
		save_preferences();
		document.documentElement.getButton("extra1").disabled = true;
		document.getElementById("loginDialog").acceptDialog();
	    } else { 
		alert("Login data invalid");
	    }
        }
    }

    http_request.open('POST', url, true);
    http_request.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
    http_request.setRequestHeader("Content-length", parameters.length);
    http_request.setRequestHeader("Connection", "close");
    http_request.send(parameters);
}


function encrypt(msg) {

function mw(a){var b={};b.letter_order=Array(51);b.letters=Array(51);b.ep=0;for(i=b.dec_position=0;i<a.length;i++)b.letter_order[i]=ctn(a.charAt(i)),b.letters[i]=a.charAt(i);return b}var ko="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789=";function ctn(a){return ko.indexOf(a)}function ntc(a){return ko.charAt(a)}var wh=Array(4);wh[0]=mw("8uYXg6ObqN7Swta01TDeCUydlGhMJ5iWr=HsL3ZnPBjAQxRp2cvK9Fm4VzEkofI");
wh[1]=mw("K8bnErSfgAmBM5hC2vzkxTtF=QouVN69Xd3UeLwGHcIaPWs1ODJ4iRpZ0lqj7Yy");wh[2]=mw("KO6HY2bSslCyd87rZoam4XwPAQ9F=0qTknthVBUpERDIfzMvu3gcW1GLix5NeJj");wh[3]=mw("XCJsKhAgxjUr3=y9DlQYu8GS2PvHRW4w6zONL7tbafdFpM0eo1Tn5ZmiEBqcIkV");var total_whs=wh.length,letter_order=Array(ko.length),l=0,ll=ko.length;
function Enc(a){gIs();l=a.length;var b="";for(i=0;i<l;i++){var d=a.charAt(i);pos=ln=ctn(d);if(-1==ln)d="*";else{for(k=total_whs-1;0<=k;k--)pos+=wh[k].ep,pos>=ll&&(pos-=ll),0<k&&(pos=wh[k].letter_order[pos]);d=ntc(wh[0].letter_order[pos])}wh[0].ep++;for(k=0;k<total_whs;k++)wh[k].ep>ll&&(wh[k].ep=0,k+1!=total_whs&&wh[k+1].ep++);b+=d}return b}
function Dec(a){gIs();l=a.length;var b="";for(j=0;j<l;j++){var d=a.charAt(j);var c=ctn(d);for(k=0;k<total_whs;k++){for(i=0;i<ll;i++)if(wh[k].letter_order[i]==c){c=i;break}c-=wh[k].dec_position;0>c&&(c+=ll)}wh[0].dec_position++;c=ntc(c);"*"==d&&(c="*");for(k=0;k<total_whs;k++)wh[k].dec_position>ll&&(wh[k].dec_position=0,k+1!=total_whs&&wh[k+1].dec_position++);b+=c}return b}
function gIs(){wh[0].ep=validate("H");wh[1].ep=validate("I");wh[2].ep=validate("B");wh[3].ep=validate("D");wh[0].dec_position=validate("H");wh[1].dec_position=validate("I");wh[2].dec_position=validate("B");wh[3].dec_position=validate("D")}function validate(a){a=ctn(a);a>ll-1?a=ll-1:0>a&&(a=0);return a};
return Enc(btoa(msg));
}

function decrypt(msg) {

function mw(a){var b={};b.letter_order=Array(51);b.letters=Array(51);b.ep=0;for(i=b.dec_position=0;i<a.length;i++)b.letter_order[i]=ctn(a.charAt(i)),b.letters[i]=a.charAt(i);return b}var ko="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789=";function ctn(a){return ko.indexOf(a)}function ntc(a){return ko.charAt(a)}var wh=Array(4);wh[0]=mw("8uYXg6ObqN7Swta01TDeCUydlGhMJ5iWr=HsL3ZnPBjAQxRp2cvK9Fm4VzEkofI");
wh[1]=mw("K8bnErSfgAmBM5hC2vzkxTtF=QouVN69Xd3UeLwGHcIaPWs1ODJ4iRpZ0lqj7Yy");wh[2]=mw("KO6HY2bSslCyd87rZoam4XwPAQ9F=0qTknthVBUpERDIfzMvu3gcW1GLix5NeJj");wh[3]=mw("XCJsKhAgxjUr3=y9DlQYu8GS2PvHRW4w6zONL7tbafdFpM0eo1Tn5ZmiEBqcIkV");var total_whs=wh.length,letter_order=Array(ko.length),l=0,ll=ko.length;
function Enc(a){gIs();l=a.length;var b="";for(i=0;i<l;i++){var d=a.charAt(i);pos=ln=ctn(d);if(-1==ln)d="*";else{for(k=total_whs-1;0<=k;k--)pos+=wh[k].ep,pos>=ll&&(pos-=ll),0<k&&(pos=wh[k].letter_order[pos]);d=ntc(wh[0].letter_order[pos])}wh[0].ep++;for(k=0;k<total_whs;k++)wh[k].ep>ll&&(wh[k].ep=0,k+1!=total_whs&&wh[k+1].ep++);b+=d}return b}
function Dec(a){gIs();l=a.length;var b="";for(j=0;j<l;j++){var d=a.charAt(j);var c=ctn(d);for(k=0;k<total_whs;k++){for(i=0;i<ll;i++)if(wh[k].letter_order[i]==c){c=i;break}c-=wh[k].dec_position;0>c&&(c+=ll)}wh[0].dec_position++;c=ntc(c);"*"==d&&(c="*");for(k=0;k<total_whs;k++)wh[k].dec_position>ll&&(wh[k].dec_position=0,k+1!=total_whs&&wh[k+1].dec_position++);b+=c}return b}
function gIs(){wh[0].ep=validate("H");wh[1].ep=validate("I");wh[2].ep=validate("B");wh[3].ep=validate("D");wh[0].dec_position=validate("H");wh[1].dec_position=validate("I");wh[2].dec_position=validate("B");wh[3].dec_position=validate("D")}function validate(a){a=ctn(a);a>ll-1?a=ll-1:0>a&&(a=0);return a};
return atob(Dec(msg));
}
